﻿#target InDesign



__main();



function __main() {
  
  if(app.documents.length == 0) { return; }
  
  var _doc = app.activeDocument, 
      _allFiles,
      _fileFormats = ".+\\.(jpg|jpeg|png|tiff|tif|psd|pdf|indd|ai|eps|gif|bmp|dcs|pict|wmf|emf|pcx|sct|swf|idms|flv|f4v|mp4|mov|avi|mpg|mp3)$",
      _pics,
      _sortMode = "None";
    
  _allFiles = File.openDialog("Please select your files:",undefined,true);   
  
  if(_allFiles == null) { return; }
  
  _pics = __filterPics (_allFiles,_fileFormats);
  _sortMode = __showUI();

  if(_sortMode == null) { return; }
  
  _pics = __sortPics (_pics,_sortMode);
  _doc.placeGuns.loadPlaceGun(_pics);

} // END function __main



// Nicht gewuenschte Dateiformate filtern
function __filterPics (_allFiles,_fileFormats) {     
  var _pics = new Array(),
      _picType,
      _target,
      _picOrNot;    
  
  for (var i=0;i<_allFiles.length;i++) {         
    _picType = new RegExp(_fileFormats);
    _target = _allFiles[i].name.toLowerCase();
    _picOrNot = _target.match(_picType);       
    if(_picOrNot != null) { _pics.push(_allFiles[i]) }   
  }     
  return _pics;
} // end function __filterPics



// Interface aufbauen
function __showUI() {
  
  var _ui = new Window("dialog","Options");
  with(_ui) {
    alignChildren = "left";   
    margins = [10,20,10,10]
    var _radiobuttonPanel = add("panel",undefined,"Sort order for files:");
    with(_radiobuttonPanel) {
      alignChildren = "left";
      margins = [13,25,25,25]
      spacing = "18";
      graphics.font = "dialog:17";
      var _groupNone = add("group");
      with(_groupNone) {
        var _sort1 = add("radiobutton",undefined,"None");
        with(_sort1) {
          value = true;
          graphics.font = "dialog:13";
          graphics.foregroundColor = graphics.newPen(graphics.PenType.SOLID_COLOR,[0.35,0.35,0.33],1);
        } // END radiobutton _sort1
      } // END group _groupNone
      var _groupName = add("group");
      with(_groupName) {
        orientation = "column";
        alignChildren = "left";
        spacing = "3";
        var _nameAsc = add("radiobutton",undefined,"Filename (ascending)");
        var _nameDesc = add("radiobutton",undefined,"Filename (descending)");
      } // END group _groupName
      var _groupCreate = add("group");
      with(_groupCreate) {
        orientation = "column";
        alignChildren = "left";
        spacing = "3";
        var _creOldFirst = add("radiobutton",undefined,"Date of Creation (oldest first)");
        var _creNewFirst = add("radiobutton",undefined,"Date of Creation (newest first)");
      } // END group _groupCreate
      var _groupModification = add("group");
      with(_groupModification) {
        orientation = "column";
        alignChildren = "left";
        spacing = "3";
        var _modOldFirst = add("radiobutton",undefined,"Date of Modification (oldest first)");
        var _modNewFirst = add("radiobutton",undefined,"Date of Modification (newest first)");
      } // END group _groupModification
      var _groupNumerical = add("group");
      with(_groupNumerical) {
        orientation = "column";
        alignChildren = "left";
        spacing = "3";
        var _numAsc = add("radiobutton",undefined,"Numerical (ascending)");
        var _numDesc = add("radiobutton",undefined,"Numerical (descending)"); 
      } // END group _groupNumerical
    } // END panel _radiobuttonPanel
    var _buttonGroup = add("group");
    with(_buttonGroup) {
      margins.top = "0";
      alignment = ["right","bottom"];
      add ("button", undefined, "Cancel");
      add ("button", undefined, "OK");  
    } // END group _buttonGroup
  } // END dialog _ui
  
  
  _groupNone.addEventListener ("click", function () {
    for (var i = 0; i < _groupName.children.length; i++) _groupName.children[i].value = false;
    for (var j = 0; j < _groupCreate.children.length; j++) _groupCreate.children[j].value = false;
    for (var k = 0; k < _groupModification.children.length; k++) _groupModification.children[k].value = false;
    for (var l = 0; l < _groupNumerical.children.length; l++) _groupNumerical.children[l].value = false;
  });
  
  _groupName.addEventListener ("click", function () {
    for (var i = 0; i < _groupNone.children.length; i++) _groupNone.children[i].value = false;
    for (var j = 0; j < _groupCreate.children.length; j++) _groupCreate.children[j].value = false;
    for (var k = 0; k < _groupModification.children.length; k++) _groupModification.children[k].value = false;
    for (var k = 0; k < _groupNumerical.children.length; k++) _groupNumerical.children[k].value = false;
  });
    
  _groupCreate.addEventListener ("click", function () {
    for (var i = 0; i < _groupNone.children.length; i++) _groupNone.children[i].value = false;
    for (var j = 0; j < _groupName.children.length; j++) _groupName.children[j].value = false;
    for (var k = 0; k < _groupModification.children.length; k++) _groupModification.children[k].value = false;
    for (var k = 0; k < _groupNumerical.children.length; k++) _groupNumerical.children[k].value = false;
  });
  
  _groupModification.addEventListener ("click", function () {
    for (var i = 0; i < _groupNone.children.length; i++) _groupNone.children[i].value = false;
    for (var j = 0; j < _groupName.children.length; j++) _groupName.children[j].value = false;
    for (var k = 0; k < _groupCreate.children.length; k++) _groupCreate.children[k].value = false;
    for (var k = 0; k < _groupNumerical.children.length; k++) _groupNumerical.children[k].value = false;
  });

  _groupNumerical.addEventListener ("click", function () {
    for (var i = 0; i < _groupNone.children.length; i++) _groupNone.children[i].value = false;
    for (var j = 0; j < _groupName.children.length; j++) _groupName.children[j].value = false;
    for (var k = 0; k < _groupCreate.children.length; k++) _groupCreate.children[k].value = false;
    for (var k = 0; k < _groupModification.children.length; k++) _groupModification.children[k].value = false;
  });

  
  var _uiSurValue = _ui.show();
  if (_uiSurValue == 2) { return null;}
  
  for(var g=0;g<_radiobuttonPanel.children.length;g++) {
    for(var r=0;r<_radiobuttonPanel.children[g].children.length;r++) {
      if (_radiobuttonPanel.children[g].children[r].value == true) {
        return _radiobuttonPanel.children[g].children[r].text;
      }
    }
  }
} // END function __showUI



// Bilddateien sortieren
function __sortPics (_pics,_sortMode) {
    
  switch (_sortMode) {
      
    case "Filename (ascending)" :
      _pics.sort(__sortAlphabetical);
      break;
    case "Filename (descending)" :
      _pics.sort(__sortAlphabetical);
      _pics.reverse();
      break;
    case "Date of Creation (oldest first)" :
      _pics.sort(function(a,b) { return a.created - b.created; });
      break;
    case "Date of Creation (newest first)" :
      _pics.sort(function(a,b) { return b.created - a.created; });
      break;
    case "Date of Modification (oldest first)" :
      _pics.sort(function(a,b) { return a.modified - b.modified; });
      break;
    case "Date of Modification (newest first)" :
      _pics.sort(function(a,b) { return b.modified - a.modified; });
      break;
    case "Numerical (ascending)" :
      _pics.sort(__sortNumerical);
      break;
    case "Numerical (descending)" :
      _pics.sort(__sortNumerical);
      _pics.reverse();
      break; 
    // Random > InDesign Crash bei aufeinanderfolgender Ausfuehrung - Bug???
    case "Random" :
      _pics.sort(function(a,b) {  
        var _res = (Math.random().toFixed(1)-0.5)*10;
        if(_res == 0) { _res = 1; }
        return _res;   
      });
      break;    
    default :   
  }
      
  function __sortAlphabetical(a,b) {       
        
    a = __removeUmlaut(File.decode(a.name));
    b = __removeUmlaut(File.decode(b.name));
      
    if (a == b) { 
      return 0; 
    }    
    if (a > b) { 
      return 1;
    } else { 
      return -1; 
    }
       
    function __removeUmlaut(_string) {
      _string = _string.toLowerCase();
      _string = _string.replace(/ä/g,"a");
      _string = _string.replace(/ö/g,"o");
      _string = _string.replace(/ü/g,"u");
      _string = _string.replace(/ß/g,"s");
      _string = _string.replace(/a\u0308/g,"a");
      _string = _string.replace(/o\u0308/g,"o");
      _string = _string.replace(/u\u0308/g,"u");
      return _string;
    } // END function __removeUmlaut	 
  } // END function __sortAlphabetical
    
  function __sortNumerical(a,b) {
    
    a = File.decode(a.name);
    b = File.decode(b.name);
    a = a.replace(/\D/g,"");
    b = b.replace(/\D/g,"");
    a = Number(a);
    b = Number(b);
    
    if(isNaN(a)) { return 0;}
    if(isNaN(b)) { return 0;}
      
    return a - b;
  } // END function __sortNumerical
    
  return _pics;
} // END function __sortPics